// ISQRS.cpp
#include <stdint.h>
#include <sys/types.h>
#include <binder/Parcel.h>
#include <utils/Log.h>
#include "ISQRS.h"

#define LOG_TAG "^^^^ISQRS.cpp"
namespace android {
	enum {
		SQUARE = IBinder::FIRST_CALL_TRANSACTION,
		MUL = IBinder::FIRST_CALL_TRANSACTION + 1,
		ADD = IBinder::FIRST_CALL_TRANSACTION + 2,
	};

	int BpSQRS::square(const int& n)
	{
LOGE("ISQRS square");
		Parcel data, reply;
		LOGE("BBpSQRS::square data.writeInt32(%d)\n",n);
		data.writeInt32(n);
		LOGE("BBpSQRS::square remote()->transact()\n");
		remote()->transact(SQUARE, data, &reply);
		//---------------------------------------------------------
		int num = reply.readInt32();
		LOGE("reply  num = %d", num);
		//---------------------------------------------------------
		return num;
	}
	int BpSQRS::mul(const int& n, const int& m) {
		Parcel data, reply;
		data.writeInt32(n);
		data.writeInt32(m);
		remote()->transact(MUL, data, &reply);
		int num = reply.readInt32();
		return num;
	}
	int BpSQRS::add(const int& x, const int& y) {
		Parcel data, reply;
		data.writeInt32(x);
		data.writeInt32(y);
		remote()->transact(ADD, data, &reply);
		int num = reply.readInt32();
		return num;
	}

IMPLEMENT_META_INTERFACE(SQRS, "android.jhc.IAS");
}; // namespace android
