// ISQRSSTub.cpp
#include <stdint.h>
#include <sys/types.h>
#include <binder/Parcel.h>
#include <utils/Log.h>
#include "ISQRSStub.h"
#define LOG_TAG "^^^^ISQRSTub.cpp" 
namespace android {
	enum {
		SQUARE = IBinder::FIRST_CALL_TRANSACTION,
		MUL = IBinder::FIRST_CALL_TRANSACTION + 1,
		ADD = IBinder::FIRST_CALL_TRANSACTION + 2,
	};

	//-------------------------------------------------------------------
	status_t BnSQRS::onTransact(uint32_t code, const Parcel& data, Parcel* reply, uint32_t flags)
	{
LOGE("start onTransact");
		switch(code) {
			case SQUARE:
				{
					LOGE("case SQUARE");
					int num = data.readInt32();
					LOGE("onTransact num = [%d]",num);
					int k = square(num); 
					LOGE("call the square, result = %d",k);

					reply->writeInt32(k);
					return NO_ERROR;
				}
				break;
			case MUL:
				{
					LOGE("case MUL");
					int num1 = data.readInt32();
					int num2 = data.readInt32();
					int k = mul(num1, num2); 
					reply->writeInt32(k);
					return NO_ERROR;
				}
				break;
			case ADD:
				{
					LOGE("case ADD");
					int num1 = data.readInt32();
					int num2 = data.readInt32();
					int k = add(num1, num2); 
					reply->writeInt32(k);
					return NO_ERROR;
				}
				break;
			default:
				LOGE("case default");

				return BBinder::onTransact(code, data, reply, flags);
		}
	}
}; // namespace android
