//SQR.cpp
#include <binder/IServiceManager.h>
#include <binder/IPCThreadState.h>
#include <utils/Log.h>
#include "SQR.h"

#define LOG_TAG "^^^^SQR.cpp"

namespace android {
  sp<IBinder> binder;
  sp<ISQRS> SQR::sSQRService;

	const sp<ISQRS>& SQR::getSQRService()
	{
		sp<IServiceManager> sm = defaultServiceManager();

		binder = sm->getService(String16("ex.svc3"));
		LOGE("----->getService done.\n");
		sSQRService = interface_cast<ISQRS>(binder);
        LOGE("----->interface_cast done.\n");
		return sSQRService;
	}

	int SQR::execute(int n)
	{
		LOGE("----->execute1..");
		int k =0;
		const sp<ISQRS>& isqrs(getSQRService());
		LOGE("----->execute2..");
		if (isqrs != 0){
			LOGE("----->execute3..");
			k = isqrs->square(n);
			LOGE("----->Result => k=%d",k);
		}
		return k;
	}
}; // namespace android
